<?php


namespace bhr\Controller;

use bhr\Model\IntegrationModel;
use bhr\Model\IgnoreDomainsModel;
use SALESmanago\Controller\ConnectSalesManagoController;
use SALESmanago\Entity\Settings;
use SALESmanago\Exception\Exception;
use SALESmanago\Exception\SalesManagoException;


class WPConnectSalesManagoController extends ConnectSalesManagoController
{
    public $ignoreDomainModel;
    public $integrationModel;

    public function __construct(Settings $settings)
    {
        parent::__construct($settings);
        $this->settings             = $settings;
        $this->integrationModel     = new IntegrationModel;
        $this->ignoreDomainModel    = new IgnoreDomainsModel;
    }

    public function checkIfIgnored($email, $plugin)
    {
        try{
            $userData = $this->ignoreDomainModel->getUserData();
            $response = $this->ignoreDomainModel->checkIfIgnored($email, $userData, $plugin);
            return $response;
        } catch (SalesManagoException $e) {
            return $e->getSalesManagoMessage();
        }
    }
}